
import QtQuick 2.0
import MuseScore 3.0

MuseScore {
   menuPath: "Plugins.Chord Add-Remove test"
   description: "Test Chord.add and Chord.remove methods."
   version: "1.0"

   // For diagnostic use.
   function dumpObjectEntries(obj, showUndefinedVals, title) {
      console.log("VV -------- " + title + " ---------- VV")
      for (let [key, value] of Object.entries(obj)) {
         if (showUndefinedVals || (value != null)) {
            console.log(key + "=" + value);
         }
      }
      console.log("^^ -------- " + title + " ---------- ^^")
   }
   function dumpNotes(elem) {
      for (var idx = 0; idx < elem.notes.length; idx++) {
         var note = elem.notes[idx]
         console.log("note[" + idx + "].pitch=" + note.pitch)
      }
   }

   function test()
   {
      if (typeof curScore === 'undefined')
         return;
      // We need a cursor
      var cursor = curScore.newCursor()

      // Assume we'll walk the entire staff.
      cursor.rewind(0);       // Start at beginning of score
      cursor.staffIdx = 0;    // Focus on first staff
      while (cursor.segment) {
         //console.log("cursor.element.type =" + cursor.element.type)
         if (cursor.element && cursor.element.type == Element.CHORD) {
            console.log("=============")
            console.log("Found a Chord")
            // -------------------------------------------------------
            // This is where you can make decisions about the current
            // chord (i.e., note cluster).
            // -------------------------------------------------------
            //dumpObjectEntries(cursor.element, false, "Chord")

            // This example only accesses the first note in the chord.
            // Note that you can easily index all the notes in a chord.
            //var note = cursor.element.notes[0];
            
            console.log("Total notes in chord=" + cursor.element.notes.length)
            dumpNotes(cursor.element);
            console.log("Call cursor.element.remove(cursor.element.notes[0])...")
            cursor.element.remove(cursor.element.notes[0])
            console.log("Total notes in chord after=" + cursor.element.notes.length)
            dumpNotes(cursor.element);
            //console.log("Remove 0th note.")
            //cursor.element.remove(note)
            //console.log("Total notes in chord=" + cursor.element.notes.length)
            // YOUR STUFF PROBABLY GOES HERE //
            // :
            // :
            //console.log("note.type =" + note.type)
            //dumpObjectEntries(note, false, "Note")
         }
         // Step to the next element.
         cursor.next();
      }
   }

   onRun: {
      console.log(description)

      test()

      console.log("Goodbye Cruel World!")

      Qt.quit()
   }
}
